#!/usr/bin/perl

# Skrypt do automatycznej zamiany okrelonych cigw znakw wystpujcych w okrelonym kontekcie
# na inne cigi znakw. Przykadowo zamianie spacji po przyimkach na &nbsp;
#
# Zaoenia. Obsugiwanych jest wiele par zamian. Kad par zamian definiuje osobny plik cfg.
# Plik cfg skada si z definicji ID danej zamiany, prefiksu (regexp) czyli cigu, ktry ma
# wystpi przez danym sowem, definicji co zamieniamy (regexp) i cigu, na ktry zamieniamy.
# Oraz listy sw, dla ktrych dokonywana jest zamiana.
# Sowa kluczowe w pliku konfiguracyjnym:
# $ID, $prefix, $replace, $final
# pozostae sowa traktowane s jako wyrazy, dla ktrych robiona jest zamiana.
#
# Skrypt czyta z wejcia standardowego i pisze na wyjcie standardowe.
# Zamiany dokonywane s globalnie. Regexpy musz by przygotowane do grupowania (w nawiasach)
#
# Autor: Pawe 'Ra' Raski rozie@wp.pl
# Licencja GPL v.2
# Wersja 0.1
# Sposb uycia: cat plik.pl.pl | perl insert_nbsp.pl


$config = "insert_nbsp.cfg";			# pena cieka do pliku konfiguracyjnego
$mainregexp = "";

# wczytanie konfiga
open (CFG,$config) or die "Cannot open $config\n";
while (<CFG>){
  if (! /^\s*#/){
    chomp;
    if (/\$ID\s(.*)/){
      $id=$1;
      if ($mainregexp =~ /./){			# jeli niepusty
	chop($mainregexp);			# usuwamy ostatnie |
	$rules{$id}{main}=$mainregexp;
	$mainregexp="";				# zerowanie
      }
    }
    elsif (/\$prefix\s(.*)/){
      $rules{$id}{prefix}=$1;
    }
    elsif (/\$replace\s(.*)/){
      $rules{$id}{replace}=$1;
    }
    elsif (/\$final\s(.*)/){
      $rules{$id}{final}=$1;
    }
    else{
      $mainregexp=$mainregexp."$_|";
    }
  }
}
close (CFG);
# obsuga koca pliku - zapisanie ostatniego regexpa
chop($mainregexp);				# usuwamy ostatnie |
$rules{$id}{main}=$mainregexp;

while (<>){
  foreach $key (keys %rules){
    $prefix=$rules{$key}{prefix};
    $replace=$rules{$key}{replace};
    $final=$rules{$key}{final};
    $main="(".$rules{$key}{main}.")";		# dooenie nawiasw
    $match=$prefix.$main.$replace;
    s/$match/$1$2$final/ig;
    print $_;
  }
}
